//
//  LogUtil.swift
//  Achilles
//
//  Created by Thierry on 16/1/8.
//  Copyright © 2016年 Thierry. All rights reserved.
//
import Foundation

/**
 Show fill log information in debug enviroment.
 
 - parameter message: log message
 - parameter file:    log in which file
 - parameter method:  log in which method
 - parameter line:    log in which line
 */
public func debugLog<T>(_ message: T,
              file: String = #file,
              method: String = #function,
              line: Int = #line) {
    #if DEBUG
        print("\((file as Foundation.NSString).lastPathComponent)[\(line)], \(method):\n \(message)\n")
    #endif
}
